--#=======================================
--# DAPESi Core function  
--#=======================================




--#==================================
--# Structure functions

function newQueue()
 local self = {}
 local push = function(v) table.insert(self,v) end
 local pop = function() return table.remove(self,1) end
 local empty = function()
					if #self == 0 then return true
					else return false
					end
			   end		
 return {
          push = push,
		  pop = pop,
		  empty = empty
		}
end
--#==================================
--# Draw functions
gfx = {}

-- Fill function using BFS algorithm
function gfx.fill(pic,x,y)
	local startColor,fifo = pic:pixel(x,y),newQueue() -- local variable
	if startColor == param.primaryCO then return pic end --if pixel color is the same as primary color , break
    fifo.push({x=x,y=y}) -- Insert start node into queue 
	pic:fillRect(x,y,file.zoom,file.zoom,param.primaryCO) -- Set tempNode with primary color 
	while not(fifo.empty()) do
		tempNode = fifo.pop() -- Get first node 
		-- for all adjacent node put into queue for evalutation
		 -- check if pixel next is on the picture and if his color is the same as startColor
		 -- is check is OK , insert next into the queue and switch pixel with primary Color 
	    if tempNode.x+file.zoom < pic:width() and pic:pixel(tempNode.x+file.zoom,tempNode.y) == startColor then
			fifo.push({x=tempNode.x+file.zoom,y=tempNode.y})
			pic:fillRect(tempNode.x+file.zoom,tempNode.y,file.zoom,file.zoom,param.primaryCO)
		end
		if tempNode.x - file.zoom >= 0 and pic:pixel(tempNode.x - file.zoom,tempNode.y) == startColor then
			fifo.push({x=tempNode.x - file.zoom,y=tempNode.y})
			pic:fillRect(tempNode.x - file.zoom,tempNode.y,file.zoom,file.zoom,param.primaryCO)
		end
		if tempNode.y+file.zoom < pic:height() and pic:pixel(tempNode.x,tempNode.y+file.zoom) == startColor then
			fifo.push({x=tempNode.x,y=tempNode.y+file.zoom})
			pic:fillRect(tempNode.x,tempNode.y+file.zoom,file.zoom,file.zoom,param.primaryCO) 
		end
		if tempNode.y - file.zoom >= 0 and pic:pixel(tempNode.x,tempNode.y - file.zoom) == startColor then	
			fifo.push({x=tempNode.x,y=tempNode.y - file.zoom})
			pic:fillRect(tempNode.x,tempNode.y - file.zoom,file.zoom,file.zoom,param.primaryCO)
		end
	end
	fifo,startColor,tempNode = nil,nil,nil
	collectgarbage()
	return pic 
end

function gfx.zoomIn(pic)
           if (pic:width() * 2) < 512 and (pic:height() * 2) < 512 then
		    file.zoom=file.zoom*2
		    local zoomPic = Image.createEmpty(pic:width()*2,pic:height()*2)
			local i,j,xz,yz = 0,0,0,0
             while yz < pic:height() do
              while xz < pic:width() do
               zoomPic:fillRect(i,j,file.zoom,file.zoom,pic:pixel(xz,yz))
               i = i + file.zoom
               xz = xz + (file.zoom/2) 
              end
              j,i,xz,yz = j + file.zoom,0,0,yz+(file.zoom/2)
             end
            return zoomPic,true
		   else
            return pic,false
           end
end		   

function gfx.zoomOut(pic)
			if file.zoom == 1 then
			 return pic,false
			else
			 file.zoom = file.zoom/2
			 local zoomPic = Image.createEmpty(pic:width()/2,pic:height()/2)
             local i,j,xz,yz = 0,0,0,0
             while yz < pic:height() do
              while xz < pic:width() do
               zoomPic:fillRect(i,j,file.zoom,file.zoom,pic:pixel(xz,yz))
               i = i + file.zoom
               xz = xz + (file.zoom*2) 
              end
              j,i,xz,yz = j + file.zoom,0,0,yz+(file.zoom*2)
             end
			 return zoomPic,true
			end
end

function gfx.line(pic,xs,ys,xf,yf)
 local xsz,ysz,xzf,yzf = xs,ys,xf,yf
 while xsz < xs+file.zoom do
  pic:drawLine(xsz,ysz,xzf,yzf,param.primaryCO)
  pic:drawLine(xsz+1,ysz,xzf,yzf+1,param.primaryCO)
  xzs,ysz,xzf,yzf = xzs+1,yzs+1,xzf+1,yzf+1
 end
 pic:drawLine(xsz,ysz,xzf,yzf,param.primaryCO)
 return pic
end