
--#=======================================================================
--# Panel
function wl.NewPanel(arg)
 local this,self = {},{w=arg.w,h=arg.h,x=arg.x,y=arg.y,mouseOver = false}
 if arg.bgcolor ~= nil then self.bgcolor = arg.bgcolor end 
 local pic = Image.createEmpty(self.w,self.h)
 local reload = function()
					if self.bgcolor == nil then pic:clear(WL_BG_COLOR) else pic:clear(self.bgcolor) end 
					if arg.border ~= nil then
					 if arg.border[1] == 1 then pic:drawLine(0,0,0,self.h-1,WL_BORDER_COLOR) end
					 if arg.border[2] == 1 then pic:drawLine(0,0,self.w-1,0,WL_BORDER_COLOR) end
					 if arg.border[3] == 1 then pic:drawLine(self.w-1,0,self.w-1,self.h-1,WL_BORDER_COLOR) end
					 if arg.border[4] == 1 then pic:drawLine(0,self.h-1,self.w-1,self.h-1,WL_BORDER_COLOR) end
					end
				end
 local update = function (i,obj)
				  this[i] = obj
				end
 reload()				
 local event = eventType()
 local connect = function(obj)
				  obj.self.x = obj.self.x + self.x 
				  obj.self.y = obj.self.y + self.y
				  obj.parent = {self=self,pic=pic,this=this,reload=reload}
				  table.insert(this,obj)
				 end
 return {this=this,self=self,event=event,connect = connect,pic=pic,update=update}
end

--#=======================================================================
--# Button
function wl.NewButton(arg)
 local self = {w=arg.w,h=arg.h,x=arg.x,y=arg.y,mouseOver = false}
 local pic = Image.createEmpty(self.w,self.h)
 pic:blit(0,0,Image.load(arg.path))
 local event = eventType()
 return {self=self,event=event,pic=pic}
end

--#=======================================================================
--# Text Field
function wl.NewTextField(arg)
 local self = {w=arg.w,h=arg.h,x=arg.x,y=arg.y,value=arg.value,mouseOver = false}
 local pic = Image.createEmpty(self.w,self.h)
 local reloadField = function()
                      pic:clear(Color.new(0,0,0,0))					  
					  pic:print(0,0,self.value,WL_TEXT_COLOR)
				     end	
 reloadField()
 local setValue = function(v) 
                   self.value = v 
				   reloadField()
				  end 
 local event = eventType()
 return {self=self,event=event,pic=pic,reloadField=reloadField,setValue=setValue}
end

--#=======================================================================
--# Color Area
function wl.NewColorArea(arg)
	local this,self = {},{w=arg.w,h=arg.h,x=arg.x,y=arg.y,mouseOver = false,color=arg.color,bordercolor=arg.bordercolor or nil}
	local pic = Image.createEmpty(self.w,self.h)
	pic = Image.createEmpty(self.w,self.h)
	local reload = function()
					pic:clear(self.color)
					if arg.border ~= nil then
						if arg.border[1] == 1 then pic:drawLine(0,0,0,self.h-1,bordercolor) end
						if arg.border[2] == 1 then pic:drawLine(0,0,self.w-1,0,bordercolor) end
						if arg.border[3] == 1 then pic:drawLine(self.w-1,0,self.w-1,self.h-1,bordercolor) end
						if arg.border[4] == 1 then pic:drawLine(0,self.h-1,self.w-1,self.h-1,bordercolor) end
					end		
				   end
	reload()
	local event = eventType()
	local connect = function(obj)
						obj.self.x = obj.self.x + self.x 
						obj.self.y = obj.self.y + self.y
						obj.parent = {self=self,pic=pic,this=this,reload=reload}
						table.insert(this,obj)
					end
	return {this=this,self=self,event=event,connect=connect,pic=pic,reload=reload}
end



--#=======================================================================
--# Draw Area
function wl.NewDrawArea(arg)
	local this,self = {},{w=arg.w,h=arg.h,x=arg.x,y=arg.y,
	                      aw=arg.aw,ah=arg.ah,ax=0,ay=0,
						  mouseOver = false,
						  bordercolor=arg.bordercolor or WL_BORDER_COLOR,
						  bgcolor=arg.bgcolor or WL_BG_COLOR,
						  abgcolor=arg.abgcolor or WL_BG_COLOR,
						  border = arg.border or {0,0,0,0},
						  bgimg = arg.bgimg or nil}
	local pic = Image.createEmpty(self.w,self.h)
	local area = Image.createEmpty(self.aw,self.ah)
	local bgimg = Image.load(self.bgimg)
    area:clear(self.abgcolor)
	local reload = function()                                                                                                
					 if self.bgimg ~= nil then pic:blit(0,0,bgimg) else pic:clear(self.bgcolor) end
					 pic:blit(file.scrollX,file.scrollY,area)
					 if self.border[1] == 1 then pic:drawLine(0,0,0,self.h-1,self.bordercolor) end
					 if self.border[2] == 1 then pic:drawLine(0,0,self.w-1,0,self.bordercolor) end
					 if self.border[3] == 1 then pic:drawLine(self.w-1,0,self.w-1,self.h-1,self.bordercolor) end
					 if self.border[4] == 1 then pic:drawLine(0,self.h-1,self.w-1,self.h-1,self.bordercolor) end

				end
 reload()				
 local event = eventType()
 local getArea = function() return area end
 local setArea = function(v) area = v end
 local reset = function() area = Image.createEmpty(100,100) area:clear(self.abgcolor) end 
 local connect = function(obj)
				  obj.self.x = obj.self.x + self.x 
				  obj.self.y = obj.self.y + self.y
				  obj.parent = {self=self,pic=pic,this=this,reload=reload}
				  table.insert(this,obj)
				 end
 return {this=this,self=self,event=event,connect=connect,pic=pic,getArea=getArea,setArea=setArea,reload=reload,reset=reset}
end

--#=======================================================================
--# Window 
function wl.NewWindow(arg)
end
--#=======================================================================
--# Menu
function wl.NewMenu(arg)
end